/*  Der Explorer soll ein Hindernis umfahren.
 *  An C1 ist der Ultrasonic-Abstandsmesser angeschlossen. Er ist vorne rechts im 45°-Winkel angebracht,
 *  um sowohl nach vorne als auch nach rechts Abstände zu erfassen.
 *  Der Befehl ftduino.ultrasonic_get() liefert dann etwa alle 250ms den nächsten Abstandswert.
 *  Dieses Intervall ist für ein zügiges Umfahren eines Hindernisses zu lang. Um die Intervalle zu verkürzen, 
 *  habe ich in ftduino.cpp das Timerintervall auf 125ms verkürzt (OCR3A = (uint16_t)(F_CPU/64/8)-1;).
 *  Der get-Befehl liefert dann gelegentlich -1.
 *  Durch die Befehle  delay(4); stopp(sp); delay(8) erreiche ich, dass die Bewegungen verkürzt werden.
 *  Eine Verkeinerung der Geschwindigkeit (speed) unter 15 ist nicht möglich, da dann die Reibung zu stark 
 *  stört. Außerdem verwende ich an I3 ein Potentiometer, um die Geschwindigkeit im Betrieb zu optimieren.
 *  So ist ein langsames Umfahren eines Hindernisses möglich.
 */
#include <adc_table.h>
#include <ftduino.h>

uint16_t sp = 35, slow, tick = 0 ;
uint16_t dis = 0,distance = 0;
void rechts(uint8_t speed)
  {slow = speed * 0.8; ftduino.motor_set(Ftduino::M2, Ftduino::RIGHT, slow );
    ftduino.motor_set(Ftduino::M3, Ftduino::RIGHT, speed ); 
    }      
void links(uint16_t speed)
  {slow = speed * 0.7; ftduino.motor_set(Ftduino::M2, Ftduino::RIGHT, speed );
    ftduino.motor_set(Ftduino::M3, Ftduino::RIGHT, slow );} 
void vorwaerts(uint16_t speed)
  {ftduino.motor_set(Ftduino::M2, Ftduino::RIGHT, speed);
    ftduino.motor_set(Ftduino::M3, Ftduino::RIGHT, speed);}   
void stopp(uint16_t speed)
  {ftduino.motor_set(Ftduino::M2, Ftduino::OFF, slow);
    ftduino.motor_set(Ftduino::M3, Ftduino::OFF, slow);}   
void setup() {
  pinMode(LED_BUILTIN, OUTPUT);
  digitalWrite(LED_BUILTIN, HIGH);
    
  ftduino.init();  
  ftduino.ultrasonic_enable(Ftduino::ON);
  ftduino.input_set_mode(Ftduino::I3, Ftduino::RESISTANCE);
  }

void loop() {
  if (tick = 20) {
  uint16_t r = ftduino.input_get(Ftduino::I3);
  sp = 0.009 * r + 12; tick = 0;}
  else {tick++;}
 
  dis = ftduino.ultrasonic_get();
  if (dis > 0) {distance = dis;}

  if (distance < 20) {links (sp * 1.2);}
    else {if (distance > 30) {rechts (sp);}
          else {vorwaerts (sp * 0.9);}} 
   delay(4 ); stopp(sp); 
   delay(8);
            
}
