
//
// begin license header
//
// This file is part of Pixy CMUcam5 or "Pixy" for short
//
// All Pixy source code is provided under the terms of the
// GNU General Public License v2 (http://www.gnu.org/licenses/gpl-2.0.html).
// Those wishing to use Pixy source code, software and/or
// technologies under different licensing terms should contact us at
// cmucam@cs.cmu.edu. Such licensing terms are available for
// all portions of the Pixy codebase presented here.
//
// end license header
//
// This sketch is uses I2C communications and Ftduino-library.  
//

#include <Ftduino.h>
#include <tpixy.h>
#include <Wire.h>

#include <pixyI2C.h>


//PixyI2C pixy;
 PixyI2C pixy(0x14); // You can set the I2C address through PixyI2C object 

  uint8_t speed = 50;


void rechts(uint8_t speed)
  {ftduino.motor_set(Ftduino::M2, Ftduino::LEFT, speed * 0.5 );
    ftduino.motor_set(Ftduino::M3, Ftduino::RIGHT, speed * 0.5 ); 
    }      
void links(uint8_t speed)
  {ftduino.motor_set(Ftduino::M2, Ftduino::RIGHT, speed * 0.5 );
    ftduino.motor_set(Ftduino::M3, Ftduino::LEFT, speed * 0.5  );}   
void zurueck(uint8_t speed)
  {ftduino.motor_set(Ftduino::M2, Ftduino::LEFT, speed );
    ftduino.motor_set(Ftduino::M3, Ftduino::LEFT, speed );} 
void vorwaerts(uint8_t speed)
  {ftduino.motor_set(Ftduino::M2, Ftduino::RIGHT, speed );
    ftduino.motor_set(Ftduino::M3, Ftduino::RIGHT, speed );} 
void stopp()
  {ftduino.motor_set(Ftduino::M2, Ftduino::OFF, speed );
    ftduino.motor_set(Ftduino::M3, Ftduino::OFF, speed );}  

void setup()
{
  pixy.init();
     ftduino.init(); 
}


void loop() 
{ static int i = 0;
  int j;
  uint16_t blocks, px, py, pb, ph;

  char buf[32]; 
  
  blocks = pixy.getBlocks();
  
  if (blocks)
  {
    i++;
    
    // do this (print) every 50 frames because printing every
    // frame would bog down the Arduino
  //  if (i%20==0)
  //  {
      sprintf(buf, "Detected %d:\n", blocks);
   //   Serial.print(buf);
      for (j=0; j<blocks; j++)
      {
        sprintf(buf, "  block %d: ", j);
     
       if (pixy.blocks[j].signature == 1) {
        px = pixy.blocks[j].x;
        py = pixy.blocks[j].y;
        pb = pixy.blocks[j].width;
        ph = pixy.blocks[j].height;
          
        if ((px < 120) && (pb > 15)) {links (speed );}
          else {if ((px > 210) && (pb > 15)) {rechts (speed );}
               else {if ((pb < 35) && (pb > 15)) {vorwaerts (speed);}
                 else {if (pb > 55) {zurueck (speed);}
                   else {stopp();}}}}
       delay(15);          
       }
       else {stopp();}          
     #ifdef USE_OLED
        display.fillRect(0, 0, 128, 32, BLACK);
        display.setCursor(64-(13*4),0);
       switch (pixy.blocks[j].signature) {
        case 1 : display.print("blau"); break;
        case 2 : display.print("grün"); break;
        case 3 : display.print("gelb"); break;
        case 4 : display.print("rot"); break;
          default : display.print("nichts");  
       }
     #endif
      }
 //   }
  } 
  else {stopp();} 
}
